%{
#include "yacc.tab.h"
#include <strings.h>

  char* unescape(char *s, int len) {
    char* ss = (char*)malloc(len+1);
    char* sss=ss;
    while (len) {
      if (*s=='\\' && len>1) {
	s++; len--;
	if (*s=='n') *ss='\n';
	else if (*s=='"') *ss='"';
	else *ss=*s;
      }
      else *ss=*s;
      s++; ss++; len--;
    }
    *ss=0;
    return sss;
  }
%}

%%

"print" return PRINT;
"input" return INPUT;
"if"    return IF;
"else"  return ELSE;
"while" return WHILE;
"proc"  return PROC;

"av"    return AV;
"td"    return TD;
"tg"    return TG;
"color" return COLOR;

"+"      return PLUS;
"-"      return MOINS;
"*"      return MULTIPLIE;
"/"      return DIVISE;

">"       return SUPERIEUR;
">="      return SUPERIEUR_EGAL;
"<"       return INFERIEUR;
"<="      return INFERIEUR_EGAL;
"!="      return DIFFERENT;
"=="      return EGAL;

"&&"      return ET;
"||"      return OU;
"!"       return NON;

"="       return ASSIGN;
","       return VIRGULE;
"("  return PARENTHESE_GAUCHE;
")"  return PARENTHESE_DROITE;
"{"  return BLOC_GAUCHE;
"}"  return BLOC_DROITE;
";"  return POINTVIRGULE;

[0-9]*"."[0-9]+ { yylval.d=atof(yytext); return NOMBRE; }
[0-9]+"."[0-9]* { yylval.d=atof(yytext); return NOMBRE; }
[0-9]+ { yylval.d=atof(yytext); return NOMBRE; }

\"([^\"\\]*(\\.)?)*\" { yylval.s=unescape(yytext+1,strlen(yytext)-2);
			       return CHAINE;}


"//".*"\n"

[ \t\n]+

[a-zA-Z][a-zA-Z0-9]* { yylval.s=strdup(yytext); return VARIABLE; }

<<eof>> return QUIT;

. return ERROR;

%%
